/*-
 * Copyright (c) 1989, 1993
 *      The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      @(#)pathnames.h 8.2 (Berkeley) 4/2/94
 */

/* Setting Files */
#define CHARSTATS_FILE		"/YOUR/PATHHERE/data/charstats"
#define MONSTER_FILE		"/YOUR/PATHHERE/data/monsters"
#define MOTD_FILE		"/YOUR/PATHHERE/data/motd"
#define PROTECTED_FILE		"/YOUR/PATHHERE/data/protected"
#define SHOPITEMS_FILE		"/YOUR/PATHHERE/data/shopitems"
#define WIZARD_FILE		"/YOUR/PATHHERE/data/wizards"

/* Data Files */
#define ACCOUNT_FILE		"/YOUR/PATHHERE/data/account"
#define TEMP_ACCOUNT_FILE	"/YOUR/PATHHERE/data/accounts.tmp"
#define NETWORK_FILE		"/YOUR/PATHHERE/data/networks"
#define TEMP_NETWORK_FILE	"/YOUR/PATHHERE/data/networks.tmp"
#define BACKUP_FILE		"/YOUR/PATHHERE/data/backup"
#define TEMP_BACKUP_FILE	"/YOUR/PATHHERE/data/backup.tmp"
#define CHARACTER_FILE		"/YOUR/PATHHERE/data/characters"
#define TEMP_CHARACTER_FILE	"/YOUR/PATHHERE/data/characters.tmp"
#define SECONDARY_CHAR_FILE	"/YOUR/PATHHERE/data/characters.2"
#define DATA_FILE		"/YOUR/PATHHERE/data/realmdata"
#define SCOREBOARD_FILE		"/YOUR/PATHHERE/data/scoreboard"
#define TEMP_SCOREBOARD_FILE	"/YOUR/PATHHERE/data/scoreboard.tmp"
#define OLD_SCOREBOARD_FILE	"/YOUR/PATHHERE/data/scoreboard.old"
#define TAG_FILE		"/YOUR/PATHHERE/data/tags"
#define TEMP_TAG_FILE		"/YOUR/PATHHERE/data/tags.tmp"
#define TAGGED_FILE		"/YOUR/PATHHERE/data/tagged"
#define TEMP_TAGGED_FILE	"/YOUR/PATHHERE/data/tagged.tmp"
#define HISTORY_FILE		"/YOUR/PATHHERE/data/history"

/* Log Files */
#define BATTLE_LOG		"/YOUR/PATHHERE/log/battles"
#define CANTRIP_LOG		"/YOUR/PATHHERE/log/cantrip"
#define CHAT_LOG		"/YOUR/PATHHERE/log/chatlog"
#define COMBAT_LOG		"/YOUR/PATHHERE/log/combat"
#define CONNECTION_LOG		"/YOUR/PATHHERE/log/connections"
#define DEBUG_LOG		"/YOUR/PATHHERE/log/debug"
#define ERROR_LOG		"/YOUR/PATHHERE/log/errorlog"
#define EVENT_LOG		"/YOUR/PATHHERE/log/events"
#define GAME_LOG		"/YOUR/PATHHERE/log/games"
#define HACK_LOG		"/YOUR/PATHHERE/log/hacks"
#define LEVEL_LOG		"/YOUR/PATHHERE/log/levels"
#define PURCHASE_LOG		"/YOUR/PATHHERE/log/purchase"
#define SERVER_LOG		"/YOUR/PATHHERE/log/server"
#define NATRESTORE_LOG              "/YOUR/PATHHERE/log/natrestore"
#define EQRESTORE_LOG	             "/YOUR/PATHHERE/log/eqrestore"
#define CRESTORE_LOG	             "/YOUR/PATHHERE/log/crestore"
#define AGERESTORE_LOG             "/YOUR/PATHHERE/log/agerestore"
#define ITEMRESTORE_LOG            "/YOUR/PATHHERE/log/itemrestore"


/* Support Files */
#define NEW_ACCOUNT_SCRIPT "/YOUR/PATHHERE/bin/new_account_mail.pl"
#define	ACCOUNT_PASSWORD_RESET_SCRIPT "/YOUR/PATHHERE/bin/account_reset_mail.pl"
#define	CHARACTER_PASSWORD_RESET_SCRIPT "/YOUR/PATHHERE/bin/character_reset_mail.pl"


